views:

509

answers:

13

I have an application where I have a number of sets. A set might be
{4, 7, 12, 18}
unique numbers and all less than 50.

I then have several data items:
1 {1, 2, 4, 7, 8, 12, 18, 23, 29}
2 {3, 4, 6, 7, 15, 23, 34, 38}
3 {4, 7, 12, 18}
4 {1, 4, 7, 12, 13, 14, 15, 16, 17, 18}
5 {2, 4, 6, 7, 13, 15}

Data items 1, 3 and 4 match the set because they contain all items in the set.

I need to design a data structure that is super fast at identifying whether a data item is a member of a set includes all the members that are part of the set (so the data item is a superset of the set). My best estimates at the moment suggest that there will be fewer than 50,000 sets.

My current implementation has my sets and data as unsigned 64 bit integers and the sets stored in a list. Then to check a data item I iterate through the list doing a ((set & data) == set) comparison. It works and it's space efficient but it's slow (O(n)) and I'd be happy to trade some memory for some performance. Does anyone have any better ideas about how to organize this?

Edit: Thanks very much for all the answers. It looks like I need to provide some more information about the problem. I get the sets first and I then get the data items one by one. I need to check whether the data item is matches one of the sets.
The sets are very likely to be 'clumpy' for example for a given problem 1, 3 and 9 might be contained in 95% of sets; I can predict this to some degree in advance (but not well).

For those suggesting memoization: this is this the data structure for a memoized function. The sets represent general solutions that have already been computed and the data items are new inputs to the function. By matching a data item to a general solution I can avoid a whole lot of processing.

+1  A: 

If you're going to improve performance, you're going to have to do something fancy to reduce the number of set comparisons you make.

Maybe you can partition the data items so that you have all those where 1 is the smallest element in one group, and all those where 2 is the smallest item in another group, and so on.

When it comes to searching, you find the smallest value in the search set, and look at the group where that value is present.

Or, perhaps, group them into 50 groups by 'this data item contains N' for N = 1..50.

When it comes to searching, you find the size of each group that holds each element of the set, and then search just the smallest group.

The concern with this - especially the latter - is that the overhead of reducing the search time might outweigh the performance benefit from the reduced search space.

Jonathan Leffler
+1. It depends on the problem domain. If the list of bit strings is known at compile time, this ought to work quite well.
EvilTeach
A: 

You can build a reverse index of "haystack" lists that contain each element:

std::set<int> needle;  // {4, 7, 12, 18}
std::vector<std::set<int>> haystacks;
// A list of your each of your data sets:
// 1 {1, 2, 4, 7, 8, 12, 18, 23, 29}
// 2 {3, 4, 6, 7, 15, 23, 34, 38}
// 3 {4, 7, 12, 18}
// 4 {1, 4, 7, 12, 13, 14, 15, 16, 17, 18}
// 5 {2, 4, 6, 7, 13, 

std::hash_map[int, set<int>>  element_haystacks;
// element_haystacks maps each integer to the sets that contain it
// (the key is the integers from the haystacks sets, and 
// the set values are the index into the 'haystacks' vector):
// 1 -> {1, 4}  Element 1 is in sets 1 and 4.
// 2 -> {1, 5}  Element 2 is in sets 2 and 4.
// 3 -> {2}  Element 3 is in set 3.
// 4 -> {1, 2, 3, 4, 5}  Element 4 is in sets 1 through 5.  
std::set<int> answer_sets;  // The list of haystack sets that contain your set.
for (set<int>::const_iterator it = needle.begin(); it != needle.end(); ++it) {
  const std::set<int> &new_answer = element_haystacks[i];
  std::set<int> existing_answer;
  std::swap(existing_answer, answer_sets);
  // Remove all answers that don't occur in the new element list.
  std::set_intersection(existing_answer.begin(), existing_answer.end(),
                        new_answer.begin(), new_answer.end(),
                        inserter(answer_sets, answer_sets.begin()));
  if (answer_sets.empty()) break;  // No matches :(
}

// answer_sets now lists the haystack_ids that include all your needle elements.
for (int i = 0; i < answer_sets.size(); ++i) {
  cout << "set: " << element_haystacks[answer_sets[i]];
}

If I'm not mistaken, this will have a max runtime of O(k*m), where is the avg number of sets that an integer belongs to and m is the avg size of the needle set (<50). Unfortunately, it'll have a significant memory overhead due to building the reverse mapping (element_haystacks).

I'm sure you could improve this a bit if you stored sorted vectors instead of sets and element_haystacks could be a 50 element vector instead of a hash_map.

Stephen
Assuming that the n=50,000 elements are distributed uniformly, every bucket will contain 25,000 entries. After all, roughly half of the sets contain, say, element 15, while half of them do not. You'll need way more than n operations to intersect buckets of this size.
Heinrich Apfelmus
@Heinrich : If the elements are distributed uniformly, wouldn't you expect 50k/50=1k elements per bucket? That means set_intersection is bounded at O(2k) comparisons. So, if your needle set is reasonably small, this should still be less than 50k comparisons. Anyways, I did have an error in my analysis. Fixed.
Stephen
No, the formula 50k/50 would be correct if the buckets were disjoint, but they aren't. For instance, the set `{1,2,...,50}` will be present in all buckets. Once again, on average, half of the 50k contain the number 15, while half of them doesn't; this makes 25k elements for bucket number 15.
Heinrich Apfelmus
@Heinrich : Inded 50k/50 would have 50k one element sets, and that's wrong. You're assuming that each haystack set will hold ~25 elements. This solution definitely breaks down with larger, overlapping haystack sets. OTOH, if there were avg 5 elements in the haystack lists, this might perform acceptably on average. If my understanding of your 25k=25elements in the set is wrong, you'll have to go into more detail of the math behind your reasoning.
Stephen
Yep, I'm assuming that each haystack has ~25 elements. That's what you get when choosing a set at random by throwing a coin on every element from 1 to 50 to decide whether it should go in or not. Of course, if the sets are *not* chosen randomly, then an average of 5 would be possible, and your proposal would indeed be able to exploit that.
Heinrich Apfelmus
A: 

Since the numbers are less than 50, you could build a one-to-one hash using a 64-bit integer and then use bitwise operations to test the sets in O(1) time. The hash creation would also be O(1). I think either an XOR followed by a test for zero or an AND followed by a test for equality would work. (If I understood the problem correctly.)

TechNeilogy
The problem isn't testing the sets in O(1) time, I already do that. The problem is reducing the number of tests, testing 50,000 sets every time I get a new data item is too slow.
Daniel
Ah, I see the issue now. It looks like something I've seen before, but I'll need to think about it a bit. Still O(1), on 50K is not shabby if you're already getting that. Maybe the "1" is too big (so to speak)?
TechNeilogy
Hash? A set that's a subset of {1,2,3,...,50} is inherently a 50-bit integer which fits nicely in `uint64_t`.
R..
Yes, that's what I meant, the membership function of the set is a 1:1 hash using a 50-bit integer. It would probably be fast enough for testing 50K sets for most purposes, say: O(A few clock cycles * 50K) Apparently there are a lot of these 50K sets to be tested, or very little time to do the testing, so some sort of partitioning or something is required. Maybe some kind of radix search on the bitset?
TechNeilogy
+1  A: 

A possible way to divvy up the list of bitmaps, would be to create an array of (Compiled Nibble Indicators)

Let's say one of your 64 bit bitmaps has the bit 0 to bit 8 set.
In hex we can look at it as 0x000000000000001F

Now, let's transform that into a simpler and smaller representation. Each 4 bit Nibble, either has at least one bit set, or not. If it does, we represent it as a 1, if not we represent it as a 0.

So the hex value reduces to bit pattern 0000000000000011, as the right hand 2 nibbles have are the only ones that have bits in them. Create an array, that holds 65536 values, and use them as a head of linked lists, or set of large arrays....

Compile each of your bit maps, into it's compact CNI. Add it to the correct list, until all of the lists have been compiled.

Then take your needle. Compile it into its CNI form. Use that to value, to subscript to the head of the list. All bitmaps in that list have a possibility of being a match. All bitmaps in the other lists can not match.

That is a way to divvy them up.

Now in practice, I doubt a linked list would meet your performance requirements.

If you write a function to compile a bit map to CNI, you could use it as a basis to sort your array by the CNI. Then have your array of 65536 heads, simply subscript into the original array as the start of a range.

Another technique would be to just compile a part of the 64 bit bitmap, so you have fewer heads. Analysis of your patterns should give you an idea of what nibbles are most effective in partitioning them up.

Good luck to you, and please let us know what you finally end up doing.

Evil.

EvilTeach
I don't think this will work. Did you calculate the expected number of entries per CNI? Assuming a uniform distribution, I'm calculating that a fraction of `(1 - (1/2)^4)^(50/4) ~ 45%` of the 50k sets will have a CNI where all bits are set; this renders your scheme rather useless, because a substantial fraction of the sets have one and the same CNI.
Heinrich Apfelmus
Yep, a judicious analysis of the patterns is called for.
EvilTeach
A: 

Put your sets into an array (not a linked list) and SORT THEM. The sorting criteria can be either 1) the number of elements in the set (number of 1-bits in the set representation), or 2) the lowest element in the set. For example, let A={7, 10, 16} and B={11, 17}. Then B<A under criterion 1), and A<B under criterion 2). Sorting is O(n log n), but I assume that you can afford some preprocessing time, i.e., that the search structure is static.

When a new data item arrives, you can use binary search (logarithmic time) to find the starting candidate set in the array. Then you search linearly through the array and test the data item against the set in the array until the data item becomes "greater" than the set.

You should choose your sorting criterion based on the spread of your sets. If all sets have 0 as their lowest element, you shouldn't choose criterion 2). Vice-versa, if the distribution of set cardinalities is not uniform, you shouldn't choose criterion 1).

Yet another, more robust, sorting criterion would be to compute the span of elements in each set, and sort them according to that. For example, the lowest element in set A is 7, and highest is 16, so you would encode its span as 0x1007; similarly the B's span would be 0x110B. Sort the sets according to the "span code" and again use binary search to find all sets with the same "span code" as your data item.

Computing the "span code" is slow in ordinary C, but it can be done fast if you resort to assembly -- most CPUs have instructions that find the most/least significant set bit.

zvrba
Don't sort by painful-to-compute criteria. Sort them simply by their value as 64-bit integers.
R..
I don't think that your suggested sorting criteria will work. Did you calculate expected run times? For instance, assuming uniform distribution, half of the 50k sets will contain the element 1, rendering sorting criterion 1) rather useless.
Heinrich Apfelmus
How can I calculate expected run-times without knowing anything about the distribution of the sets? That's why I suggested several criteria. And I guess you meant criterion 2).
zvrba
Well, you can assume the worst case, which is a uniform distribution. Oops, I meant criterion 2), indeed.
Heinrich Apfelmus
A: 

This is not a real answer more an observation: this problem looks like it could be efficiently parallellized or even distributed, which would at least reduce the running time to O(n / number of cores)

Christoffer
+1  A: 

You could use inverted index of your data items. For your example

1 {1, 2, 4, 7, 8, 12, 18, 23, 29}
2 {3, 4, 6, 7, 15, 23, 34, 38}
3 {4, 7, 12, 18}
4 {1, 4, 7, 12, 13, 14, 15, 16, 17, 18}
5 {2, 4, 6, 7, 13, 15}

the inverted index will be

1: {1, 4}
2: {1, 5}
3: {2}
4: {1, 2, 3, 4, 5}
5: {}
6: {2, 5}
...

So, for any particular set {x_0, x_1, ..., x_i} you need to intersect sets for x_0, x_1 and others. For example, for the set {2,3,4} you need to intersect {1,5} with {2} and with {1,2,3,4,5}. Because you could have all your sets in inverted index sorted, you could intersect sets in min of lengths of sets that are to be intersected.

Here could be an issue, if you have very 'popular' items (as 4 in our example) with huge index set.

Some words about intersecting. You could use sorted lists in inverted index, and intersect sets in pairs (in increasing length order). Or as you have no more than 50K items, you could use compressed bit sets (about 6Kb for every number, fewer for sparse bit sets, about 50 numbers, not so greedily), and intersect bit sets bitwise. For sparse bit sets that will be efficiently, I think.

Dmitry
+2  A: 

I can't prove it, but I'm fairly certain that there is no solution that can easily beat the O(n) bound. Your problem is "too general": every set has m = 50 properties (namely, property k is that it contains the number k) and the point is that all these properties are independent of each other. There aren't any clever combinations of properties that can predict the presence of other properties. Sorting doesn't work because the problem is very symmetric, any permutation of your 50 numbers will give the same problem but screw up any kind of ordering. Unless your input has a hidden structure, you're out of luck.

However, there is some room for speed / memory tradeoffs. Namely, you can precompute the answers for small queries. Let Q be a query set, and supersets(Q) be the collection of sets that contain Q, i.e. the solution to your problem. Then, your problem has the following key property

Q ⊆ P  =>  supersets(Q) ⊇ supersets(P)

In other words, the results for P = {1,3,4} are a subcollection of the results for Q = {1,3}.

Now, precompute all answers for small queries. For demonstration, let's take all queries of size <= 3. You'll get a table

supersets({1})
supersets({2})
...
supersets({50})
supersets({1,2})
supersets({2,3})
...
supersets({1,2,3})
supersets({1,2,4})
...

supersets({48,49,50})

with O(m^3) entries. To compute, say, supersets({1,2,3,4}), you look up superset({1,2,3}) and run your linear algorithm on this collection. The point is that on average, superset({1,2,3}) will not contain the full n = 50,000 elements, but only a fraction n/2^3 = 6250 of those, giving an 8-fold increase in speed.

(This is a generalization of the "reverse index" method that other answers suggested.)

Depending on your data set, memory use will be rather terrible, though. But you might be able to omit some rows or speed up the algorithm by noting that a query like {1,2,3,4} can be calculated from several different precomputed answers, like supersets({1,2,3}) and supersets({1,2,4}), and you'll use the smallest of these.

Heinrich Apfelmus
I lean towards your idea that O(n) can't be beat for general purpose implementations.
TechNeilogy
You can't prove it because it's not true: with unbounded amounts of space, O(# of distinct numbers) is trivial in the pointer machine model.
Ah, you could store all results, but that's kinda degenerate. A reasonable bound on space, for instance "polynomial in # of distinct numbers" excludes this solution.
Heinrich Apfelmus
+1  A: 

The index of the sets that match the search criterion resemble the sets themselves. Instead of having the unique indexes less than 50, we have unique indexes less than 50000. Since you don't mind using a bit of memory, you can precompute matching sets in a 50 element array of 50000 bit integers. Then you index into the precomputed matches and basically just do your ((set & data) == set) but on the 50000 bit numbers which represent the matching sets. Here's what I mean.

#include <iostream>

enum
{
    max_sets = 50000, // should be >= 64
    num_boxes = max_sets / 64 + 1,
    max_entry = 50
};

uint64_t sets_containing[max_entry][num_boxes];

#define _(x) (uint64_t(1) << x)

uint64_t sets[] =
{
    _(1) | _(2) | _(4) | _(7) | _(8) | _(12) | _(18) | _(23) | _(29),
    _(3) | _(4) | _(6) | _(7) | _(15) | _(23) | _(34) | _(38),
    _(4) | _(7) | _(12) | _(18),
    _(1) | _(4) | _(7) | _(12) | _(13) | _(14) | _(15) | _(16) | _(17) | _(18),
    _(2) | _(4) | _(6) | _(7) | _(13) | _(15),
    0,
};

void big_and_equals(uint64_t lhs[num_boxes], uint64_t rhs[num_boxes])
{
    static int comparison_counter = 0;
    for (int i = 0; i < num_boxes; ++i, ++comparison_counter)
    {
        lhs[i] &= rhs[i];
    }
    std::cout
        << "performed "
        << comparison_counter
        << " comparisons"
        << std::endl;
}

int main()
{
    // Precompute matches
    memset(sets_containing, 0, sizeof(uint64_t) * max_entry * num_boxes);

    int set_number = 0;
    for (uint64_t* p = &sets[0]; *p; ++p, ++set_number)
    {
        int entry = 0;
        for (uint64_t set = *p; set; set >>= 1, ++entry)
        {
            if (set & 1)
            {
                std::cout
                    << "sets_containing["
                    << entry
                    << "]["
                    << (set_number / 64)
                    << "] gets bit "
                    << set_number % 64
                    << std::endl;

                uint64_t& flag_location =
                    sets_containing[entry][set_number / 64];

                flag_location |= _(set_number % 64);
            }
        }
    }

    // Perform search for a key
    int key[] = {4, 7, 12, 18};
    uint64_t answer[num_boxes];
    memset(answer, 0xff, sizeof(uint64_t) * num_boxes);

    for (int i = 0; i < sizeof(key) / sizeof(key[0]); ++i)
    {
        big_and_equals(answer, sets_containing[key[i]]);
    }

    // Display the matches
    for (int set_number = 0; set_number < max_sets; ++set_number)
    {
        if (answer[set_number / 64] & _(set_number % 64))
        {
            std::cout
                << "set "
                << set_number
                << " matches"
                << std::endl;
        }
    }

    return 0;
}

Running this program yields:

sets_containing[1][0] gets bit 0
sets_containing[2][0] gets bit 0
sets_containing[4][0] gets bit 0
sets_containing[7][0] gets bit 0
sets_containing[8][0] gets bit 0
sets_containing[12][0] gets bit 0
sets_containing[18][0] gets bit 0
sets_containing[23][0] gets bit 0
sets_containing[29][0] gets bit 0
sets_containing[3][0] gets bit 1
sets_containing[4][0] gets bit 1
sets_containing[6][0] gets bit 1
sets_containing[7][0] gets bit 1
sets_containing[15][0] gets bit 1
sets_containing[23][0] gets bit 1
sets_containing[34][0] gets bit 1
sets_containing[38][0] gets bit 1
sets_containing[4][0] gets bit 2
sets_containing[7][0] gets bit 2
sets_containing[12][0] gets bit 2
sets_containing[18][0] gets bit 2
sets_containing[1][0] gets bit 3
sets_containing[4][0] gets bit 3
sets_containing[7][0] gets bit 3
sets_containing[12][0] gets bit 3
sets_containing[13][0] gets bit 3
sets_containing[14][0] gets bit 3
sets_containing[15][0] gets bit 3
sets_containing[16][0] gets bit 3
sets_containing[17][0] gets bit 3
sets_containing[18][0] gets bit 3
sets_containing[2][0] gets bit 4
sets_containing[4][0] gets bit 4
sets_containing[6][0] gets bit 4
sets_containing[7][0] gets bit 4
sets_containing[13][0] gets bit 4
sets_containing[15][0] gets bit 4
performed 782 comparisons
performed 1564 comparisons
performed 2346 comparisons
performed 3128 comparisons
set 0 matches
set 2 matches
set 3 matches

3128 uint64_t comparisons beats 50000 comparisons so you win. Even in the worst case, which would be a key which has all 50 items, you only have to do num_boxes * max_entry comparisons which in this case is 39100. Still better than 50000.

Ken Smith
+1  A: 

I'm surprised no one has mentioned that the STL contains an algorithm to handle this sort of thing for you. Hence, you should use includes. As it describes it performs at most 2*(N+M)-1 comparisons for a worst case performance of O(M+N).

Hence:

bool isContained = includes( myVector.begin(), myVector.end(), another.begin(), another.end() );

if you're needing O( log N ) time, I'll have to yield to the other responders.

wheaties
That's true, where "this sort of thing" doesn't categorize the difficult parts of the problem... He has 50k "anothers". `includes` doesn't reduce that set... I'm guessing no one mentioned it because it wasn't particularly relevant.
Stephen
A: 

How many data items do you have? Are they really all unique? Could you cache popular data items, or use a bucket/radix sort before the run to group repeated items together?

Here is an indexing approach:

1) Divide the 50-bit field into e.g. 10 5-bit sub-fields. If you really have 50K sets then 3 17-bit chunks might be nearer the mark.

2) For each set, choose a single subfield. A good choice is the sub-field where that set has the most bits set, with ties broken almost arbitrarily - e.g. use the leftmost such sub-field.

3) For each possible bit-pattern in each sub-field note down the list of sets which are allocated to that sub-field and match that pattern, considering only the sub-field.

4) Given a new data item, divide it into its 5-bit chunks and look each up in its own lookup table to get a list of sets to test against. If your data is completely random you get a factor of two speedup or more, depending on how many bits are set in the densest sub-field of each set. If an adversary gets to make up random data for you, perhaps they find data items that almost but not quite match loads of sets and you don't do very well at all.

Possibly there is scope for taking advantage of any structure in your sets, by numbering bits so that sets tend to have two or more bits in their best sub-field - e.g. do cluster analysis on the bits, treating them as similar if they tend to appear together in sets. Or if you can predict patterns in the data items, alter the allocation of sets to sub-fields in step(2) to reduce the number of expected false matches.

Addition: How many tables would need to have to guarantee that any 2 bits always fall into the same table? If you look at the combinatorial definition in http://en.wikipedia.org/wiki/Projective_plane, you can see that there is a way to extract collections of 7 bits from 57 (=1 + 7 + 49) bits in 57 different ways so that for any two bits at least one collection contains both of them. Probably not very useful, but it's still an answer.

mcdowella
+4  A: 

I see another solution which is dual to yours (i.e., testing a data item against every set) and that is using a binary tree where each node tests whether a specific item is included or not.

For instance if you had the sets A = { 2, 3 } and B = { 4 } and C = { 1, 3 } you'd have the following tree

                      _NOT_HAVE_[1]___HAVE____
                      |                      |            
                _____[2]_____          _____[2]_____
                |           |          |           |
             __[3]__     __[3]__    __[3]__     __[3]__
             |     |     |     |    |     |     |     |
            [4]   [4]   [4]   [4]  [4]   [4]   [4]   [4]
            / \   / \   / \   / \  / \   / \   / \   / \
           .   B .   B .   B .   B    B C   B A   A A   A
                                            C     B C   B
                                                        C

After making the tree, you'd simply need to make 50 comparisons---or how ever many items you can have in a set.

For instance, for { 1, 4 }, you branch through the tree : right (the set has 1), left (doesn't have 2), left, right, and you get [ B ], meaning only set B is included in { 1, 4 }.

This is basically called a "Binary Decision Diagram". If you are offended by the redundancy in the nodes (as you should be, because 2^50 is a lot of nodes...) then you should consider the reduced form, which is called a "Reduced, Ordered Binary Decision Diagram" and is a commonly used data-structure. In this version, nodes are merged when they are redundant, and you no longer have a binary tree, but a directed acyclic graph.

The Wikipedia page on ROBBDs can provide you with more information, as well as links to libraries which implement this data-structure for various languages.

Jérémie
You're right and this is probably the full extent of the memory/performance trade off. My maths suggests that the basic BDT needs 2^51 = 2,251,799,813,685,248 nodes which will use 2 petabytes even if you structure it like a heap. I'm interested in the ROBDD, I'll get reading.
Daniel
So, your idea is to precalculate a table of all answers and try to compress it afterwards. Nice, though compression will probably be very difficult.
Heinrich Apfelmus
Heinrich, reducing the decision diagram is done using an inductive set of simple rules; these rules are implemented in all (RO)BDD libraries so you don't really have to bother about them :-) On the other hand, if you want more information, here are slides (the bit about reduction is on slide 15): http://smv.unige.ch/members/hostettler/hidden/presentations/ROBDD.pdf
Jérémie
Related: http://stackoverflow.com/questions/3411283/binary-decision-diagram-library-for-windows
Daniel
Jérémie, thanks for the pointer! What I mean is that Daniel might be unlucky and his BDD doesn't get compressed very well; is there any rule of thumb which BDDs are amenable to compression? I mean, for text files, it's "one kind of character used more than others || many repetitions", but for BDDs?
Heinrich Apfelmus
By the way, your example diagram mixes up super- and subsets. The question is not very clear, but I think Daniel means that the query is a *subset* of one of the stored sets, not the other way round.
Heinrich Apfelmus
I believe he stores sets A, B, C, and wants to be able to query whether a given set X (which he calls a "data item") is a superset of any of the stored sets A, B, C. But beyond that, super/subsets amount the same thing: as you know, A is included in B IFF non(B) is included in non(A). I mean that you can go from one to the other by inverting all tests.
Jérémie
About compression: no I don't know of a similar rule of thumb for boolean functions. ROBDDs are assumed to be amongst the most efficient way of storing a boolean function---when you want to manipulate it. There must be a distribution analysis somewhere (if not: it would be an interesting topic). An important factor is that ROBDDs are Ordered, and it turns out that the order of the nodes/questions influences what reductions are possible. (I'm sorry for this brief answer but you can't write that much in these comments!! :-)
Jérémie
I'm going to accept this answer as it seems to be the consensus (on votes) and because it seems most likely to me to be successful. Unfortunately I haven't yet been able to prototype it as I can't find a suitable library (see related question). If I find one I'll update with results.
Daniel
A: 

Another idea is to completely prehunt your elephants.

Setup

Create a 64 bit X 50,000 element bit array.

Analyze your search set, and set the corresponding bits in each row.

Save the bit map to disk, so it can be reloaded as needed.

Searching

Load the element bit array into memory.

Create a bit map array, 1 X 50000. Set all of the values to 1. This is the search bit array

Take your needle, and walk though each value. Use it as a subscript into the element bit array. Take the corresponding bit array, then AND it into the search array.

Do that for all values in your needle, and your search bit array, will hold a 1, for every matching element.

Reconstruct

Walk through the search bit array, and for each 1, you can use the element bit array, to reconstruct the original values.

EvilTeach
*prehunt your elephants* I like that turn of phrase.
Paul Nathan
It's from an old joke about a vice president, and his staff.
EvilTeach